/* Copyright (c) Eclipseina GmbH 2018
 * ALL RIGHTS RESERVED
 *
 * Redistribution or use of this source file or it's binary form,
 * with or without modification
 * is not permitted without the written permission of Eclipseina GmbH.
 *
 * Filename: ec32demo.h
 * Description:
 * Created on: 05.09.2018
 *
 * License key:358o167me81da0721nie5775s09pi2753lc77e93
 */


#ifndef EC32INCLUDES_EC32DEMO_H_
#define EC32INCLUDES_EC32DEMO_H_

#include "ec32demodatatypes.h"
#include "ec32demodefines.h"




/*
 * Macros
 */
#define ECLIB_MUL_32(res, par1, par2) \
		Eclib_Mul_32( ECLIB_PASS_FIX32(&res), ECLIB_PASS_FIX32(par1), ECLIB_PASS_FIX32(par2) )		// Eclib_Mul_32( (&res), (&res_sf), (par1), (par1_sf), (par2), (par2_sf) )
#define ECLIB_SQUARE_32(res, par) \
		Eclib_Square_32( ECLIB_PASS_FIX32(&res), ECLIB_PASS_FIX32(par) )	// Eclib_Square_32( (&res), (&res_sf), (par), (par_sf) )
#define ECLIB_IS_EQUAL_32(res, par1, par2) \
		res = Eclib_IsEqual_32( ECLIB_PASS_FIX32(par1), ECLIB_PASS_FIX32(par2))				// res = Eclib_IsEqual_32( (par1), (par1_sf), (par2), (par2_sf))
#define ECLIB_IS_LESS_OR_EQUAL_32(res, par1, par2) \
		res = Eclib_IsLessOrEqual_32( ECLIB_PASS_FIX32(par1), ECLIB_PASS_FIX32(par2))		// res = Eclib_IsLessOrEqual_32( (par1), (par1_sf), (par2), (par2_sf))


/*
 * Functions
 */
void Eclib_Mul_32(ECLIB_RCV_FIX32(*res), ECLIB_RCV_FIX32(par1), ECLIB_RCV_FIX32(par2));
void Eclib_Square_32(ECLIB_RCV_FIX32(*res), ECLIB_RCV_FIX32(par));
ECLIB_Bool Eclib_IsEqual_32( ECLIB_RCV_FIX32(par1), ECLIB_RCV_FIX32(par2));
ECLIB_Bool Eclib_IsLessOrEqual_32( ECLIB_RCV_FIX32(par1), ECLIB_RCV_FIX32(par2)) ;


#endif /* EC32INCLUDES_EC32DEMO_H_ */
